#include "Appevent.ch"
#include "xbp.ch"
#include "GRA.CH"

PROCEDURE AppSys
RETURN

PROCEDURE Main( cFileName )
LOCAL nEvent, mp1, mp2, oXbp
LOCAL cText, oMLE
LOCAL oDlg
LOCAL oStatic
LOCAL aChild

   IF Empty(cFileName) .OR. ! File(cFileName)
      WAIT "Dateiname mu angegeben werden"
      QUIT
   ENDIF

   oDlg          := XbpDialog():new(AppDesktop() ,, {100,50}, {600,480} )
   oDlg:title    := "Parent is Application Window"
   oDlg:Tasklist := .T.
   oDlg:useVisualStyle := .F.
   oDlg:drawingArea:ColorBG := -255
   oDlg:drawingArea:clipChildren := .T.
   oDlg:drawingArea:clipParent   := .T.
   oDlg:clipSiblings := .T.
   oDlg:drawingArea:clipSiblings := .T.
   oDlg:create()

   // Test-Datei in LOCAL Variable einlesen
   cText := MemoRead( cFileName )

   // MLE erzeugen, Position bei :create() angeben
   // und Datencodeblock mit Zugriff auf LOCAL Variable erzeugen
   oMLE          := XbpMLE():new(oDlg:drawingArea   , , {20,20}, {550,300} )
   oMLE:wordWrap :=.F.
   oMLE:dataLink := {|x| IIf( x==NIL, cText, cText := x ) }
   oMLE:clipSiblings := .F.
   oMLE:useVisualStyle := .F.
   oMLE:create()
   oMLE:SetColorBG( GRA_CLR_YELLOW )

   // Text aus LOCAL Variable in Editierpuffer bertragen
   // Das erfolgt via :dataLink
   oMLE:setData()

   // Event loop = Programmsteuerung
   nEvent := 0
   DO WHILE nEvent <> xbeP_Close
      nEvent := AppEvent( @mp1, @mp2, @oXbp )
      oXbp:handleEvent( nEvent, mp1, mp2 )
   ENDDO

   // Text aus Editierpuffer holen und an LOCAL Variable zuweisen
   // Die Zuweisung erfolgt durch :dataLink
   oMLE:getData()

   // Text von der LOCAL Variablen in Datei zurckschreiben
   IF oMLE:changed
      MemoWrit( cFileName, cText )
   ENDIF

RETURN